﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Hosting;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.DependencyInjection;

namespace SessionState
{
    public class Startup
    {
        // This method gets called by the runtime. Use this method to add services to the container.
        // For more information on how to configure your application, visit https://go.microsoft.com/fwlink/?LinkID=398940
        public void ConfigureServices(IServiceCollection services)
        {
            services.AddDistributedMemoryCache();
            //services.AddSession();

            services.AddSession(options => {
                options.Cookie.HttpOnly = true;
                options.Cookie.Name = ".Sanshi.Session";
                options.Cookie.SecurePolicy = CookieSecurePolicy.SameAsRequest;
                options.IdleTimeout = TimeSpan.FromMinutes(10);
            });
        }

        // This method gets called by the runtime. Use this method to configure the HTTP request pipeline.
        public void Configure(IApplicationBuilder app, IHostingEnvironment env)
        {
            app.UseSession();

            //app.Use(async (context, next) =>
            //{
            //    context.Session.SetString("GreetingMessage", "Hello Session State");
            //    await next();
            //});
            //app.Run(async (context) =>
            //{
            //    var message = context.Session.GetString("GreetingMessage");
            //    await context.Response.WriteAsync($"{message}");
            //});


            
            app.Use(async (context, next) =>
            {
                context.Session.SetObject("CurrentUser",
                    new UserInfo { Username = "James", Email = "james@bond.com" });
                await next();
            });
            app.Run(async (context) =>
            {
                var user = context.Session.GetObject<UserInfo>("CurrentUser");
                await context.Response.WriteAsync($"{user.Username}, {user.Email}");
            });
            
        }
    }
}
